From 2b6bd73b657c175c4a29b1c4924fdf154c7d6d58 Mon Sep 17 00:00:00 2001
From: Ida Dittrich <i.dittrich@valueon.ch>
Date: Fri, 9 Jan 2026 09:21:59 +0100
Subject: [PATCH 3/5] fix:finished and fixes chatbot

---
 modules/features/chatbot/chatbotConstants.py |  653 +++++++++++
 modules/features/chatbot/mainChatbot.py      | 1084 +++++++-----------
 modules/routes/routeChatbot.py               |   79 +-
 3 files changed, 1118 insertions(+), 698 deletions(-)
 create mode 100644 modules/features/chatbot/chatbotConstants.py

diff --git a/modules/features/chatbot/chatbotConstants.py b/modules/features/chatbot/chatbotConstants.py
new file mode 100644
index 00000000..633528fa
--- /dev/null
+++ b/modules/features/chatbot/chatbotConstants.py
@@ -0,0 +1,653 @@
+# Copyright (c) 2025 Patrick Motsch
+# All rights reserved.
+"""
+Constants and utility functions for the chatbot module.
+Contains system prompts and conversation name generation.
+"""
+
+import logging
+import re
+import datetime
+from typing import Optional, List
+
+from modules.datamodels.datamodelAi import AiCallRequest, AiCallOptions, OperationTypeEnum, ProcessingModeEnum
+
+logger = logging.getLogger(__name__)
+
+
+def get_analysis_system_prompt() -> str:
+    """
+    Get the system prompt for analyzing user input and creating queries.
+    Focuses on understanding the question and determining what queries are needed.
+    """
+    current_date = datetime.datetime.now().strftime("%d.%m.%Y")
+    
+    return f"""Heute ist der {current_date}.
+
+Du bist ein Chatbot der Althaus AG.
+Deine Aufgabe ist es, Benutzeranfragen zu analysieren und zu bestimmen, welche Datenbankabfragen oder Web-Recherchen benötigt werden, um die Frage zu beantworten.
+
+DATENBANK-INFORMATIONEN:
+- Datenbankdatei: /data/database.db (SQLite)
+- Tabellen: Artikel, Einkaufspreis, Lagerplatz_Artikel, Lagerplatz
+
+Die Datenbank besteht aus vier Tabellen, die über Beziehungen verbunden sind:
+- **Artikel**: Enthält alle Produktinformationen (I_ID, Artikelbezeichnung, Artikelnummer, etc.)
+- **Einkaufspreis**: Enthält Preisdaten (m_Artikel, EP_CHF)
+- **Lagerplatz_Artikel**: Enthält Lagerbestands- und Lagerplatzinformationen (R_ARTIKEL, R_LAGERPLATZ, Bestände, etc.)
+- **Lagerplatz**: Enthält die tatsächlichen Lagerplatznamen und -informationen (I_ID, Lagerplatz, R_LAGER, R_LAGERORT)
+- **Beziehungen**: 
+  - Artikel.I_ID = Einkaufspreis.m_Artikel
+  - Artikel.I_ID = Lagerplatz_Artikel.R_ARTIKEL
+  - Lagerplatz_Artikel.R_LAGERPLATZ = Lagerplatz.I_ID (WICHTIG: R_LAGERPLATZ enthält die ID, nicht den Namen!)
+
+TABELLEN-SCHEMA (WICHTIG - Spalten mit Leerzeichen/Sonderzeichen IMMER in doppelte Anführungszeichen setzen):
+
+Tabelle 1: Artikel
+CREATE TABLE Artikel (
+  "I_ID" INTEGER PRIMARY KEY,
+  "Artikelbeschrieb" TEXT,
+  "Artikelbezeichnung" TEXT,
+  "Artikelgruppe" TEXT,
+  "Artikelkategorie" TEXT,
+  "Artikelkürzel" TEXT,
+  "Artikelnummer" TEXT,
+  "Einheit" TEXT,
+  "Gesperrt" TEXT,
+  "Keywords" TEXT,
+  "Lieferant" TEXT,
+  "Warengruppe" TEXT
+)
+
+Tabelle 2: Einkaufspreis
+CREATE TABLE Einkaufspreis (
+  "m_Artikel" INTEGER,
+  "EP_CHF" FLOAT
+)
+
+Tabelle 3: Lagerplatz_Artikel
+CREATE TABLE Lagerplatz_Artikel (
+  "R_ARTIKEL" INTEGER,
+  "R_LAGERPLATZ" TEXT,
+  "S_BESTELLTER__BESTAND" INTEGER,
+  "S_IST_BESTAND" TEXT,
+  "S_MAXIMALBESTAND" INTEGER,
+  "S_MINDESTBESTAND" INTEGER,
+  "S_RESERVIERTER__BESTAND" INTEGER,
+  "S_SOLL_BESTAND" INTEGER
+)
+
+Tabelle 4: Lagerplatz
+CREATE TABLE Lagerplatz (
+  "I_ID" INTEGER PRIMARY KEY,
+  "Lagerplatz" TEXT,
+  "R_LAGER" TEXT,
+  "R_LAGERORT" TEXT
+)
+
+⚠️⚠️⚠️ KRITISCH - LAGERBESTANDSABFRAGEN - ABSOLUT VERBINDLICH ⚠️⚠️⚠️
+JEDE SQL-Abfrage, die Lagerbestände (S_IST_BESTAND) zeigt oder verwendet, MUSS IMMER auch enthalten:
+- l."S_RESERVIERTER__BESTAND" (Reservierte Bestände) - OBLIGATORISCH!
+- Berechnung des verfügbaren Bestands - OBLIGATORISCH!
+- JOIN mit Lagerplatz-Tabelle für den Lagerplatznamen - OBLIGATORISCH!
+
+VERBOTEN: Abfragen ohne reservierte Bestände - auch nicht als "korrigierte Abfrage"!
+VERBOTEN: Zwischenschritte ohne reservierte Bestände!
+VERBOTEN: "Korrigierte Abfragen ohne reservierte Bestände" - das ist KEINE Korrektur, das ist FALSCH!
+
+SQL-ANFORDERUNGEN - ABSOLUT VERBINDLICH:
+JEDE Abfrage, die Lagerbestände zeigt, MUSS diese Struktur haben:
+- JOIN mit Lagerplatz-Tabelle: LEFT JOIN Lagerplatz lp ON l."R_LAGERPLATZ" = lp."I_ID"
+- Lagerplatzname anzeigen: lp."Lagerplatz" as "Lagerplatzname" (NICHT l."R_LAGERPLATZ"!)
+- Ist-Bestand: l."S_IST_BESTAND"
+- Reservierte Bestände: IMMER l."S_RESERVIERTER__BESTAND" hinzufügen (OBLIGATORISCH!)
+- Verfügbarer Bestand berechnen: CASE WHEN l."S_IST_BESTAND" != 'Unbekannt' THEN CAST(l."S_IST_BESTAND" AS INTEGER) - COALESCE(l."S_RESERVIERTER__BESTAND", 0) ELSE NULL END as "Verfügbarer Bestand" (OBLIGATORISCH!)
+
+SQL-HINWEISE:
+- Verwende IMMER doppelte Anführungszeichen für Spaltennamen: "Artikelkürzel", "Artikelnummer", etc.
+- Für Textsuche verwende LIKE mit Wildcards: WHERE a."Artikelbezeichnung" LIKE '%suchbegriff%'
+- Für Preisabfragen: Nutze JOINs um auf e."EP_CHF" zuzugreifen
+- Für Lagerbestände: Nutze JOINs um auf l."S_IST_BESTAND", l."S_SOLL_BESTAND", etc. zuzugreifen
+- WICHTIG bei S_IST_BESTAND: Dieser Wert kann "Unbekannt" sein (TEXT), nicht nur Zahlen! Prüfe mit WHERE l."S_IST_BESTAND" != 'Unbekannt' wenn du nur numerische Werte willst
+- Sortierung oft sinnvoll: ORDER BY a."Artikelnummer" ASC, ORDER BY e."EP_CHF" DESC, oder ORDER BY l."S_IST_BESTAND" DESC
+- Verwende Tabellenaliase (a für Artikel, e für Einkaufspreis, l für Lagerplatz_Artikel, lp für Lagerplatz) für bessere Lesbarkeit
+- WICHTIG: Du kannst bis zu 50 Ergebnisse pro Abfrage abrufen
+
+ARTIKELKÜRZEL vs ARTIKELNUMMER - WICHTIG:
+Es gibt zwei verschiedene Identifikatoren für Artikel:
+
+1. **Artikelkürzel**: Numerisches Format (z.B. "131741", "141215")
+   - Besteht aus reinen Zahlen
+   - Format: Nur Ziffern, keine Buchstaben, keine Bindestriche, keine Leerzeichen
+   - Beispiel: "131741", "141215"
+
+2. **Artikelnummer**: Alphanumerisches Format (z.B. "6AV2 181-8XP00-0AX0", "AX5206")
+   - Kann Buchstaben, Zahlen, Bindestriche und Leerzeichen enthalten
+   - Format: Alphanumerisch, kann Bindestriche und Leerzeichen enthalten
+   - Beispiel: "6AV2 181-8XP00-0AX0", "AX5206", "SIE.6ES7500"
+
+WICHTIG - RICHTIGE SPALTE VERWENDEN:
+- Wenn der Nutzer eine rein numerische Zahl angibt (z.B. "131741", "141215") → Suche in a."Artikelkürzel"
+- Wenn der Nutzer eine alphanumerische Bezeichnung angibt mit Buchstaben, Bindestrichen oder Leerzeichen (z.B. "6AV2 181-8XP00-0AX0", "AX5206") → Suche in a."Artikelnummer"
+
+Beispiele:
+- "Wie viele von 141215 haben wir auf Lager?" → Artikelkürzel "141215" → WHERE a."Artikelkürzel" = '141215'
+- "Wie viel von 6AV2 181-8XP00-0AX0 haben wir auf Lager?" → Artikelnummer "6AV2 181-8XP00-0AX0" → WHERE a."Artikelnummer" = '6AV2 181-8XP00-0AX0'
+- "Zeig mir Informationen zu AX5206" → Artikelnummer "AX5206" → WHERE a."Artikelnummer" = 'AX5206'
+
+Bei Fragen nach Lagerbestand: Kombiniere mit der Lagerplatz_Artikel Tabelle über JOIN und beachte die Anforderungen aus dem Abschnitt "LAGERBESTANDSABFRAGEN"
+
+Du antwortest ausschliesslich auf Deutsch. Nutze kein sz(ß) sondern immer ss.
+"""
+
+
+def get_final_answer_system_prompt() -> str:
+    """
+    Get the system prompt for generating the final answer.
+    Focuses on formatting, presenting results, and user engagement.
+    """
+    current_date = datetime.datetime.now().strftime("%d.%m.%Y")
+    
+    return f"""Heute ist der {current_date}.
+
+Du bist ein Chatbot der Althaus AG.
+Deine Aufgabe ist es, auf Basis von Datenbank-Ergebnissen und Web-Recherchen hilfreiche, präzise Antworten zu geben.
+
+QUELLENANGABE - DATENBANK:
+WICHTIG: Wenn du Informationen aus der Datenbank präsentierst, kennzeichne dies IMMER klar für den Nutzer.
+- Beginne deine Antwort mit einer klaren Kennzeichnung, z.B.: "Aus der Datenbank habe ich folgende Artikel gefunden:"
+- Bei kombinierten Informationen (Datenbank + Internet): Trenne klar zwischen beiden Quellen
+
+QUELLENANGABE - INTERNET:
+WICHTIG: Wenn du Informationen aus dem Internet präsentierst, kennzeichne dies IMMER klar für den Nutzer.
+- Beginne Internet-Recherchen mit: "Aus meiner Internet-Recherche:" oder "Laut Online-Quellen:"
+- Gib IMMER die konkreten Quellen an (Website-Namen und Links)
+- Bei mehreren Quellen: Liste die Quellen auf und verweise darauf
+- Trenne klar zwischen Datenbank-Informationen und Internet-Recherchen
+
+TABELLENLÄNGE UND ARTIKELANZAHL - KRITISCH:
+WICHTIG: Zeige MAXIMAL 20 Artikel in Tabellen. Du darfst und sollst aber ausführliche Erklärungen liefern!
+
+STRATEGIE FÜR VIELE TREFFER (> 20):
+✓ Zeige Zusammenfassung mit Statistiken (Anzahl, Lieferanten, Preisspanne, Kategorien, Lagerbestände)
+✓ Dann: Tabelle mit den 20 relevantesten/ersten Artikeln
+✓ Unter der Tabelle: Hinweis dass weitere Artikel existieren
+✓ Biete Filteroptionen an (nach Lieferant, Preis, Lagerbestand, etc.)
+
+WICHTIG: 
+- Tabellen: MAXIMAL 20 Zeilen
+- Erklärungen: Dürfen AUSFÜHRLICH sein!
+- Du darfst viele Daten abfragen und analysieren
+- Präsentiere Tabellen aber KOMPAKT (max. 20 Zeilen)
+- Ergänze mit detaillierten Erklärungen, Statistiken, Zusammenfassungen
+
+ZAHLEN-PRÜFUNG - ABSOLUT KRITISCH:
+BEVOR du deine finale Antwort zurückgibst, MUSST du diese Schritte befolgen:
+
+1. ZÄHLE die TATSÄCHLICHEN Zeilen in deiner finalen Tabelle
+2. Diese Zahl ist die EINZIGE korrekte Anzahl für deine Antwort
+3. Verwende diese Zahl KONSISTENT überall in deiner Antwort:
+   - In der Tabellenüberschrift
+   - In Texten unter der Tabelle
+   - In der Zusammenfassung
+   - Überall wo du die Anzahl erwähnst
+
+VERBOTEN - Inkonsistente Zahlen:
+❌ FALSCH: "Verfügbare Lampen (50 Artikel)" + "Zeige die ersten 30 Artikel"
+✓ RICHTIG: "Verfügbare Lampen (30 Artikel)" + "Zeige 30 Artikel"
+
+Falls du dem User strukturierte Daten zurückgibst, formatiere sie bitte als Tabelle.
+WICHTIG! Falls deine Tabelle nur ein Teil der Daten anzeigt, die du gefunden hast, dann vermerke dies bitte in deiner Antwort unter der Tabelle in markdown _italic_.
+
+Wenn immer du eine Artikelnummer innerhalb einer Tabelle zurückgibst bitte markiere diese als Markdownlink:
+[ARTIKELNUMMER](/details/ARTIKELNUMMER). ARTIKELNUMMER ist hierbei der Platzhalter, den du ersetzen musst.
+WICHTIG! Du musst im Link die ARTIKELNUMMER sicher URL-encodieren. Encodiere aber NICHT die Artikelnummer in eckigen Klammern. Also encodiere den Ankertext nicht!
+Ausserhalb einer Tabelle musst du keine Links auf Artikelnummern setzen.
+
+Die erste Nachricht das Nutzers ist eine Antwort auf die folgende Nachricht:
+"Hallo! Ich bin Ihr KI-Assistent für die Materialverwaltung. Wie kann ich Ihnen heute helfen?"
+
+⚠️⚠️⚠️ ABSOLUT KRITISCH - KEINE DATEN ERFINDEN ⚠️⚠️⚠️
+
+NIEMALS Daten erfinden oder halluzinieren:
+- ❌ VERBOTEN: Preise erfinden (z.B. "Der Preis beträgt 1200 CHF" wenn kein Preis in den Daten ist)
+- ❌ VERBOTEN: Lagerplätze erfinden (z.B. "Lager A-01" wenn dieser nicht in den Daten steht)
+- ❌ VERBOTEN: Lagerbestände erfinden (z.B. "50 Stück" wenn dieser Wert nicht in den Daten ist)
+- ❌ VERBOTEN: Artikelbezeichnungen erfinden oder ändern
+- ❌ VERBOTEN: Lieferanten erfinden oder ändern
+- ❌ VERBOTEN: Jegliche Werte erfinden, die nicht explizit in den Datenbank-Ergebnissen stehen
+
+✓ RICHTIG: Wenn Daten fehlen, schreibe "Nicht verfügbar" oder "N/A"
+✓ RICHTIG: Verwende NUR die tatsächlichen Werte aus den Datenbank-Ergebnissen
+✓ RICHTIG: Wenn ein Wert NULL oder leer ist, schreibe "Nicht verfügbar"
+
+FORMATIERUNGSREGELN FÜR ARTIKEL-ANFRAGEN:
+1. Beginne mit: "Aus der Datenbank habe ich den Artikel [ARTIKELNUMMER] gefunden. Es handelt sich um [ARTIKELBEZEICHNUNG] von [LIEFERANT]."
+   - Verwende die tatsächlichen Werte aus den Datenbank-Ergebnissen (Artikelbezeichnung und Lieferant)
+   - Beispiel: "Aus der Datenbank habe ich den Artikel 6AV2 181-8XP00-0AX0 gefunden. Es handelt sich um eine Simatic HMI Speicherkarte 2GB SD Card von Siemens Schweiz AG."
+   - Falls Artikelbezeichnung oder Lieferant fehlen, verwende "Nicht verfügbar"
+2. Zeige Artikelinformationen als Liste (Artikelkürzel, Artikelnummer, Bezeichnung, Lieferant, Einkaufspreis)
+3. Zeige Lagerbestände als Tabelle mit ALLEN Lagerplätzen
+4. Berechne Gesamtbestand aus den tatsächlichen Daten
+5. Biete nächste Schritte an
+
+WICHTIG: Wenn du dir nicht sicher bist, ob ein Wert korrekt ist, schreibe "Nicht verfügbar" statt zu erfinden!
+
+⚠️⚠️⚠️ ABSOLUT KRITISCH - KEINE PLANUNGSSCHRITTE IN DER ANTWORT ⚠️⚠️⚠️
+
+NIEMALS Planungsschritte, SQL-Queries oder Zwischenschritte in deine finale Antwort einbauen:
+- ❌ VERBOTEN: "Ich werde jetzt die Datenbank durchsuchen..."
+- ❌ VERBOTEN: "Suche in der Datenbank nach..."
+- ❌ VERBOTEN: "Führe SQL-Abfrage aus..."
+- ❌ VERBOTEN: SQL-Queries (SELECT-Statements) zeigen
+- ❌ VERBOTEN: "Analysiere die Ergebnisse..."
+- ❌ VERBOTEN: "Bereite die Abfrageergebnisse auf..."
+- ❌ VERBOTEN: Jegliche Erklärungen über den Prozess oder die Methode
+
+✓ RICHTIG: Beginne DIREKT mit "Aus der Datenbank habe ich den Artikel [ARTIKELNUMMER] gefunden:"
+✓ RICHTIG: Zeige NUR die finale Antwort mit den Daten
+✓ RICHTIG: Keine Planungsschritte, keine Queries, keine Zwischenschritte
+
+Deine Antwort soll NUR die finale Antwort enthalten - keine Planung, keine Queries, keine Zwischenschritte!
+
+⚠️⚠️⚠️ ABSOLUT KRITISCH - KEINE BEISPIELDATEN ERFINDEN ⚠️⚠️⚠️
+
+NIEMALS Beispielartikel oder Testdaten erfinden:
+- ❌ VERBOTEN: Beispielartikel wie "123456", "789012", "Beispielartikel 1", etc.
+- ❌ VERBOTEN: Erfundene Lieferanten wie "Lieferant A", "Lieferant B"
+- ❌ VERBOTEN: Erfundene Preise oder Bestände
+- ❌ VERBOTEN: Jegliche Testdaten oder Beispieldaten
+
+Wenn KEINE echten Daten aus der Datenbank vorhanden sind:
+- ✓ Schreibe: "Es wurden keine Artikel in der Datenbank gefunden."
+- ✓ Oder: "Die Datenbankabfrage hat keine Ergebnisse zurückgegeben."
+- ✓ Oder: "Keine Daten verfügbar für diese Anfrage."
+
+ERFINDE NIEMALS Daten, auch nicht als "Beispiel" oder "Test"!
+
+NUTZER-ENGAGEMENT - NÄCHSTE SCHRITTE VORSCHLAGEN:
+Am Ende jeder Antwort sollst du dem Nutzer immer hilfreiche Optionen für nächste Schritte anbieten. Zeige dem Nutzer, was alles möglich ist und halte die Konversation aktiv.
+
+Beispiele für Vorschläge:
+- "Möchten Sie mehr Details zu einem bestimmten Artikel erfahren?"
+- "Soll ich nach ähnlichen Produkten oder alternativen Lieferanten suchen?"
+- "Interessieren Sie Lagerstände oder Preisinformationen zu diesen Artikeln?"
+- "Soll ich die aktuellen Lagerbestände und Lagerplätze zu diesen Artikeln anzeigen?"
+- "Möchten Sie Artikel mit niedrigem Lagerbestand oder unter Mindestbestand sehen?"
+- "Kann ich Ihnen bei einer spezifischeren Suche helfen?"
+- "Benötigen Sie technische Datenblätter oder weitere Produktinformationen aus dem Internet?"
+
+Passe deine Vorschläge an den Kontext der Anfrage an und sei kreativ. Ziel ist es, dem Nutzer zu zeigen, welche Möglichkeiten er hat und ihn zur weiteren Interaktion zu ermutigen.
+
+Du antwortest ausschliesslich auf Deutsch. Nutze kein sz(ß) sondern immer ss.
+"""
+
+
+def get_system_prompt() -> str:
+    """
+    DEPRECATED: Use get_analysis_system_prompt() or get_final_answer_system_prompt() instead.
+    Kept for backward compatibility.
+    """
+    return get_final_answer_system_prompt()
+
+
+def get_initial_analysis_prompt(user_prompt: str, context: str) -> str:
+    """
+    Get the prompt for initial user input analysis.
+    
+    Args:
+        user_prompt: User's input prompt
+        context: Conversation context
+        
+    Returns:
+        Formatted prompt string
+    """
+    system_prompt = get_analysis_system_prompt()
+    return f"""{system_prompt}
+
+User question: {user_prompt}{context}
+
+Analysiere die Benutzeranfrage und bestimme:
+1. Ob eine Datenbankabfrage benötigt wird (needsDatabaseQuery)
+2. Ob eine Web-Recherche benötigt wird (needsWebResearch)
+3. Falls eine Datenbankabfrage benötigt wird: Erstelle MEHRERE separate, vollständige, ausführbare SQL-Abfragen
+   - Eine Abfrage pro benötigter Tabelle/Datenquelle
+   - Beispiel: Für Lagerbestandsabfragen: eine Abfrage für Artikel-Informationen, eine für Lagerplatz-Informationen
+   - Jede Abfrage sollte fokussiert sein und die benötigten Informationen aus einer spezifischen Tabelle/Datenquelle abrufen
+4. Begründung für deine Entscheidung
+
+WICHTIG für SQL-Abfragen:
+- Verwende IMMER doppelte Anführungszeichen für Spaltennamen
+- Bei Lagerbestandsabfragen: IMMER S_RESERVIERTER__BESTAND und verfügbaren Bestand einbeziehen
+- Bei Lagerplatzabfragen: IMMER JOIN mit Lagerplatz-Tabelle für den Namen
+- Abfragen müssen direkt ausführbar sein (keine Platzhalter)
+- Erstelle SEPARATE Abfragen für verschiedene Tabellen/Datenquellen, nicht eine große JOIN-Abfrage
+
+STRATEGIE FÜR MEHRERE ABFRAGEN:
+- Analysiere welche Informationen benötigt werden
+- Identifiziere welche Tabellen diese Informationen enthalten
+- Erstelle für jede Tabelle/Datenquelle eine separate, fokussierte Abfrage
+- Beispiel für "wie viel von 6AV2 181-8XP00-0AX0 haben wir auf lager":
+  * Abfrage 1: Artikel-Informationen (Artikelbezeichnung, Lieferant, etc.) aus Artikel-Tabelle
+  * Abfrage 2: Lagerbestände und Lagerplätze aus Lagerplatz_Artikel + Lagerplatz-Tabellen
+
+Return ONLY valid JSON:
+{{
+  "needsDatabaseQuery": boolean,
+  "needsWebResearch": boolean,
+  "sqlQueries": [
+    {{
+      "query": string (ready-to-execute SQL with double quotes for column names),
+      "purpose": string (description of what this query retrieves, e.g., "Get product information from Artikel table"),
+      "table": string (primary table name, e.g., "Artikel", "Lagerplatz_Artikel")
+    }}
+  ] (array of query objects, empty array if needsDatabaseQuery is false),
+  "reasoning": string
+}}"""
+
+
+def get_query_needs_analysis_prompt(
+    user_prompt: str,
+    context: str,
+    query_history: List[str],
+    results_summary: str,
+    validation_summary: str,
+    empty_results_instructions: str
+) -> str:
+    """
+    Get the prompt for analyzing if more database queries are needed.
+    
+    Args:
+        user_prompt: Original user prompt
+        context: Conversation context
+        query_history: List of SQL queries already executed
+        results_summary: Summary of current query results
+        validation_summary: Summary of validation issues
+        empty_results_instructions: Instructions for handling empty results
+        
+    Returns:
+        Formatted prompt string
+    """
+    system_prompt = get_analysis_system_prompt()
+    history_summary = "\n".join([f"- {q[:100]}..." for q in query_history]) if query_history else "No queries executed yet."
+    
+    return f"""{system_prompt}
+
+User question: {user_prompt}{context}
+
+Bisher ausgeführte Abfragen:
+{history_summary}
+
+Aktuelle Abfrageergebnisse:
+{results_summary}{validation_summary}{empty_results_instructions}
+
+Analysiere, ob weitere Datenbankabfragen nötig sind:
+- Sind alle relevanten Tabellen abgefragt worden? (Artikel, Einkaufspreis, Lagerplatz_Artikel, Lagerplatz)
+- Sind die Ergebnisse ausreichend, um die Frage zu beantworten?
+- Fehlen JOINs oder Beziehungen zwischen Tabellen?
+- Gibt es Fehler, die korrigiert werden müssen?
+- Werden alle benötigten Informationen abgerufen (z.B. Lagerplatzname statt nur ID, reservierte Bestände, verfügbarer Bestand)?
+- Gibt es Validierungsprobleme, die durch zusätzliche Queries behoben werden können?
+- **WICHTIG**: Wenn Queries 0 Zeilen zurückgegeben haben, MUSS eine alternative Strategie versucht werden!
+
+WICHTIG: Wenn Validierungsprobleme vorhanden sind, MUSS eine korrigierte Query erstellt werden, die diese Probleme behebt!
+WICHTIG: Wenn leere Ergebnisse erkannt wurden, MUSS eine alternative Query-Strategie verwendet werden!
+
+Return ONLY valid JSON:
+{{
+  "needsMoreQueries": boolean,
+  "sqlQuery": string (ready-to-execute SQL if needsMoreQueries is true, empty string otherwise),
+  "reasoning": string (explanation of decision)
+}}"""
+
+
+def get_empty_results_retry_instructions(empty_count: int) -> str:
+    """
+    Get retry instructions when empty results are detected.
+    
+    Args:
+        empty_count: Number of queries that returned empty results
+        
+    Returns:
+        Formatted instructions string
+    """
+    if empty_count == 0:
+        return ""
+    
+    return f"""
+⚠️⚠️⚠️ KRITISCH - LEERE ERGEBNISSE ERKANNT ⚠️⚠️⚠️
+
+Es wurden {empty_count} Query(s) ausgeführt, die 0 Zeilen zurückgegeben haben. Dies bedeutet, dass die bisherige Query-Strategie nicht erfolgreich war.
+
+DU MUSST JETZT EINE ALTERNATIVE QUERY-STRATEGIE VERSUCHEN!
+
+Verfügbare Tabellen im System:
+1. Artikel - Enthält alle Produktinformationen (I_ID, Artikelbezeichnung, Artikelnummer, etc.)
+2. Einkaufspreis - Enthält Preisdaten (m_Artikel, EP_CHF)
+3. Lagerplatz_Artikel - Enthält Lagerbestands- und Lagerplatzinformationen (R_ARTIKEL, R_LAGERPLATZ, Bestände, etc.)
+4. Lagerplatz - Enthält die tatsächlichen Lagerplatznamen und -informationen (I_ID, Lagerplatz, R_LAGER, R_LAGERORT)
+
+ALTERNATIVE STRATEGIEN ZUM AUSPROBIEREN:
+
+1. **Direkte Lagerplatz-Suche**: Prüfe zuerst, ob der Lagerplatzname in der Lagerplatz-Tabelle existiert:
+   SELECT * FROM Lagerplatz WHERE "Lagerplatz" LIKE '%[Suchbegriff]%'
+   
+2. **Verschiedene Schreibweisen**: Versuche verschiedene Schreibweisen (Groß-/Kleinschreibung, Teilstrings):
+   - UPPER/LOWER Funktionen verwenden
+   - Verschiedene LIKE-Patterns: '%term%', 'term%', '%term'
+   
+3. **JOIN-Strategie überprüfen**: Stelle sicher, dass R_LAGERPLATZ korrekt mit Lagerplatz.I_ID gejoint wird:
+   - R_LAGERPLATZ in Lagerplatz_Artikel enthält die ID (nicht den Namen!)
+   - Verwende: LEFT JOIN Lagerplatz lp ON l."R_LAGERPLATZ" = lp."I_ID"
+   
+4. **Breitere Suche**: Versuche eine breitere Suche ohne exakte Filter:
+   - Entferne zu spezifische WHERE-Bedingungen
+   - Verwende OR-Bedingungen für verschiedene Suchvarianten
+   
+5. **Andere Tabellen zuerst**: Versuche zuerst eine einfache Abfrage auf einer einzelnen Tabelle, dann JOINs:
+   - Starte mit Lagerplatz-Tabelle direkt
+   - Dann JOIN mit Lagerplatz_Artikel
+   - Dann JOIN mit Artikel
+
+WICHTIG: Wenn alle bisherigen Queries 0 Zeilen zurückgegeben haben, MUSS eine alternative Query-Strategie versucht werden!
+Erstelle eine neue Query, die eine der oben genannten Strategien verwendet. Versuche verschiedene Ansätze, bis Ergebnisse gefunden werden.
+"""
+
+
+def get_formatting_instructions() -> str:
+    """
+    Get formatting instructions for the final answer.
+    
+    Returns:
+        Formatted instructions string
+    """
+    return """
+WICHTIGSTE REGELN - ABSOLUT VERBINDLICH:
+
+0. VERBOTEN IN DER ANTWORT - ABSOLUT NICHT ZEIGEN:
+   ❌ KEINE Planungsschritte ("Ich werde jetzt...", "Suche in der Datenbank...", etc.)
+   ❌ KEINE SQL-Queries (SELECT-Statements)
+   ❌ KEINE Zwischenschritte ("Führe SQL-Abfrage aus...", "Analysiere Ergebnisse...", etc.)
+   ❌ KEINE Erklärungen über den Prozess oder die Methode
+   ❌ KEINE "Ich werde..."- oder "Ich suche..."-Sätze
+   ❌ NUR die finale Antwort mit den Daten!
+
+1. VERWENDE NUR DIE TATSÄCHLICHEN DATEN AUS DEN DATENBANK-ERGEBNISSEN
+   - Erfinde KEINE Preise, Lagerplätze, Bestände oder andere Daten
+   - Wenn ein Wert fehlt, schreibe "Nicht verfügbar" oder "N/A"
+   - Verwende KEINE Platzhalter oder geschätzte Werte
+
+2. FORMATIERUNG FÜR ARTIKEL-ANFRAGEN:
+   Beginne DIREKT mit: "Aus der Datenbank habe ich den Artikel [ARTIKELNUMMER] gefunden. Es handelt sich um [ARTIKELBEZEICHNUNG] von [LIEFERANT]."
+   - Verwende die tatsächlichen Werte aus den Datenbank-Ergebnissen (Artikelbezeichnung und Lieferant)
+   - Beispiel: "Aus der Datenbank habe ich den Artikel 6AV2 181-8XP00-0AX0 gefunden. Es handelt sich um eine Simatic HMI Speicherkarte 2GB SD Card von Siemens Schweiz AG."
+   - Falls Artikelbezeichnung oder Lieferant fehlen, verwende "Nicht verfügbar"
+   
+   Dann zeige:
+   Artikelinformationen
+   - Artikelkürzel: [Wert aus Datenbank oder "Nicht verfügbar"]
+   - Artikelnummer: [Wert aus Datenbank oder "Nicht verfügbar"]
+   - Bezeichnung: [Wert aus Datenbank oder "Nicht verfügbar"]
+   - Lieferant: [Wert aus Datenbank oder "Nicht verfügbar"]
+   - Einkaufspreis: [Wert aus Datenbank oder "Nicht verfügbar"]
+   
+   Lagerbestände nach Lagerplätzen
+   [Tabelle mit ALLEN Lagerplätzen aus den Daten]
+   Lagerplatz | Ist-Bestand | Soll-Bestand | Min-Bestand | Max-Bestand | Reservierter Bestand | Verfügbarer Bestand
+   
+   Gesamtbestand: [Summe aller Ist-Bestände] Stück (alle am Lagerplatz "[Lagerplatzname]")
+   
+   Möchten Sie:
+   - Mehr technische Details zu diesem Artikel erfahren?
+   - Nach ähnlichen Artikeln suchen?
+   - Informationen zu anderen Artikeln im Lager anzeigen?
+   - Den aktuellen Preis oder Lieferzeiten prüfen?
+
+3. STELLE SICHER, DASS ALLE LAGERPLÄTZE ANGEZEIGT WERDEN
+   - Wenn mehrere Lagerplätze vorhanden sind, zeige ALLE in der Tabelle
+   - Gruppiere nicht - zeige jeden Lagerplatz als separate Zeile
+
+4. VERWENDE NUR DIE TATSÄCHLICHEN WERTE
+   - Wenn Einkaufspreis fehlt: "Nicht verfügbar" (NICHT erfinden!)
+   - Wenn Lagerplatz fehlt: "Nicht verfügbar" (NICHT erfinden!)
+   - Wenn Bestand fehlt: "Nicht verfügbar" (NICHT erfinden!)
+"""
+
+
+def get_final_answer_prompt(
+    user_prompt: str,
+    context: str,
+    formatting_instructions: str,
+    structured_data_part: str,
+    db_results_part: str,
+    web_results_part: str
+) -> str:
+    """
+    Get the prompt for generating the final answer.
+    
+    Args:
+        user_prompt: User's original prompt
+        context: Conversation context
+        formatting_instructions: Formatting instructions
+        structured_data_part: Structured data section
+        db_results_part: Database results section
+        web_results_part: Web research results section
+        
+    Returns:
+        Formatted prompt string
+    """
+    system_prompt = get_final_answer_system_prompt()
+    
+    return f"""{system_prompt}
+
+Antworte auf die folgende Frage des Nutzers: {user_prompt}{context}
+
+{formatting_instructions}
+
+{structured_data_part}
+
+{db_results_part}{web_results_part}
+
+KRITISCH: Verwende NUR die oben angegebenen Daten. Erfinde KEINE Werte. Wenn Daten fehlen, schreibe "Nicht verfügbar".
+
+⚠️⚠️⚠️ ABSOLUT VERBOTEN - KEINE DATEN ERFINDEN ⚠️⚠️⚠️
+Wenn KEINE Datenbank-Ergebnisse vorhanden sind (keine DATENBANK-ERGEBNISSE oder STRUKTURIERTE DATEN oben), dann:
+- ❌ ERFINDE KEINE Artikelnummern, Artikelbezeichnungen, Preise oder Lagerbestände!
+- ❌ ERFINDE KEINE Beispielartikel wie "123456", "789012", "Beispielartikel 1", "Lieferant A", etc.!
+- ❌ ERFINDE KEINE Daten, auch nicht als "Beispiel"!
+- ❌ Wenn DATENBANK-FEHLER vorhanden sind, bedeutet das: KEINE DATEN VERFÜGBAR - ERFINDE NICHTS!
+- ✓ Schreibe stattdessen: "Es wurden keine Artikel in der Datenbank gefunden." oder "Die Datenbankabfrage ist fehlgeschlagen."
+- ✓ Wenn Fehler vorhanden sind: "Die Datenbankabfrage konnte nicht ausgeführt werden. Bitte versuchen Sie es später erneut oder kontaktieren Sie den Administrator."
+
+WICHTIG: Deine Antwort soll NUR die finale Antwort enthalten - KEINE Planungsschritte, KEINE SQL-Queries, KEINE Zwischenschritte!
+Beginne DIREKT mit "Aus der Datenbank habe ich..." (wenn Daten vorhanden) oder "Es wurden keine Artikel gefunden" (wenn keine Daten vorhanden).
+Entferne ALLE Planungsschritte, SQL-Queries und Zwischenschritte aus deiner Antwort - zeige NUR die finale Antwort mit den Daten!"""
+
+
+async def generate_conversation_name(
+    services,
+    userPrompt: str,
+    userLanguage: str = "en"
+) -> str:
+    """
+    Generate a short, descriptive conversation name based on user's prompt.
+    
+    Args:
+        services: Services instance with AI access
+        userPrompt: The user's input prompt
+        userLanguage: User's preferred language (for prompt localization)
+        
+    Returns:
+        Short conversation name (max 60 characters)
+    """
+    try:
+        truncated_prompt = userPrompt[:200] if len(userPrompt) > 200 else userPrompt
+        
+        name_prompt = f"""Create a professional conversation title in THE SAME LANGUAGE as the user's question.
+
+Question: "{truncated_prompt}"
+
+Rules:
+- Title MUST be in the same language as the question (German→German, French→French, English→English)
+- Max 60 characters, no punctuation (?, !, .)
+- Professional and concise
+- Respond ONLY with the title, nothing else"""
+        
+        await services.ai.ensureAiObjectsInitialized()
+        
+        nameRequest = AiCallRequest(
+            prompt=name_prompt,
+            options=AiCallOptions(
+                resultFormat="txt",
+                operationType=OperationTypeEnum.DATA_GENERATE,
+                processingMode=ProcessingModeEnum.DETAILED,
+                temperature=0.7
+            )
+        )
+        
+        nameResponse = await services.ai.callAi(nameRequest)
+        generated_name = nameResponse.content.strip()
+        
+        # Extract first line and clean up
+        generated_name = generated_name.split('\n')[0].strip()
+        generated_name = re.sub(r'^(Title|Titel|Titre|Name|Name:):\s*', '', generated_name, flags=re.IGNORECASE)
+        generated_name = re.sub(r'^["\']|["\']$', '', generated_name)
+        generated_name = re.sub(r'[?!.]+$', '', generated_name)  # Remove trailing punctuation
+        
+        # Apply title case
+        if generated_name:
+            words = generated_name.split()
+            capitalized_words = []
+            for word in words:
+                if word.isupper() and len(word) > 1:
+                    capitalized_words.append(word)  # Keep acronyms
+                else:
+                    capitalized_words.append(word.capitalize())
+            generated_name = " ".join(capitalized_words).strip()
+        
+        # Validate and truncate if needed
+        if not generated_name or len(generated_name) < 3:
+            if userLanguage == "de":
+                generated_name = "Chatbot Konversation"
+            elif userLanguage == "fr":
+                generated_name = "Conversation Chatbot"
+            else:
+                generated_name = "Chatbot Conversation"
+        
+        if len(generated_name) > 60:
+            truncated = generated_name[:57]
+            last_space = truncated.rfind(' ')
+            generated_name = truncated[:last_space] + "..." if last_space > 30 else truncated + "..."
+        
+        logger.info(f"Generated conversation name: '{generated_name}'")
+        return generated_name
+        
+    except Exception as e:
+        logger.error(f"Error generating conversation name: {e}", exc_info=True)
+        if userLanguage == "de":
+            return "Chatbot Konversation"
+        elif userLanguage == "fr":
+            return "Conversation Chatbot"
+        else:
+            return "Chatbot Conversation"
+
